# Gradient Descent
# Need to get y_for_q6 from Q5
x=x_for_q6
y=y_for_q6
amplitude=np.max(y)
# normalize y_max as 1e3
nrml=1e3
y/=amplitude
y*=nrml
amplitude=nrml


### 구현하기
def intensity(k, beta):
  global amplitude, x
  return amplitude*(np.sin(k*x)/k/x)**2*(np.cos(beta*x))**2

"""
def dI_dk(k):
  global x, amplitude
  num=2*amplitude*np.cos(beta*x)**2*np.sin(k*x)*(k*x*np.cos(k*x)-np.sin(k*x))
  denum=k**3*x**2
  return num/denum

def dI_dbeta(beta):
  global x, amplitude
  num=2*amplitude*np.sin(beta*x)*np.cos(beta*x)*np.sin(k*x)**2
  denum=k**2*x
  return num/denum
"""

def df_dx(func, k, beta):
  global amplitude, x
  h=1e-8
  df_dk=(func(k+h, beta)-func(k-h, beta))/(2*h)
  df_dbeta=(func(k, beta+h)-func(k, beta-h))/(2*h)
  return df_dk, df_dbeta

# LSQ=1/N*SUM((y_pred-y_true)**2)
def LSE(k, beta):
  global x, y, intensity
  lse=np.mean((intensity(k, beta)-y)**2)    # use mean
  return lse

if __name__=="__main__":
  learning_rate = 1e-2
  lsq_all = []

  # beta가 Local Minimum에 빠지지 않기 위해서는 beta 초기화를 해와 충분히 가깝게 해야함
  k=10; beta=5000
  for i in range(1000):
    lsq=LSE(k, beta)
    # grad_k=(2*(intensity(k, beta)-y)*dI_dk(k)).mean()
    # grad_beta=(2*(intensity(k, beta)-y)*dI_dbeta(beta)).mean()
    dk, dbeta=df_dx(intensity, k, beta)
    grad_k=np.mean(2*(intensity(k, beta)-y)*dk)
    grad_beta=np.mean(2*(intensity(k, beta)-y)*dbeta)
    k-=grad_k*learning_rate
    beta-=grad_beta*learning_rate
    lsq_all.append(lsq)

  plt.plot(lsq_all, color="#ff00ff")
  plt.title("Loss")
  plt.yscale("log"); plt.ylabel(f"$Loss[log]$")
  plt.show()
  print("\n", end="", flush=True)

  y_pred=intensity(k, beta)
  ax=plt.subplot(121)
  ax.plot(x, y, color="#00a3d2")
  ax.set_title("y_true")
  plt.xticks([]); plt.yticks([])
  ax=plt.subplot(122)
  ax.plot(x, y_pred, color="#881824")
  ax.set_title("y_pred")
  plt.xticks([]); plt.yticks([])
  plt.show()
  print("\n", end="", flush=True)
  
  plt.plot(x, y, color="#00a3d2", alpha=0.7, label="y_true")
  plt.plot(x, y_pred, color="#881824", alpha=0.7, label="y_pred")
  plt.title("k=%.2f, beta=%.2f" %(k, beta))
  plt.legend()
  plt.show()
